(function(){
    
    openerp.partner_print_credit = {};

    openerp.partner_print_credit.PrintCreditWidget = openerp.Widget.extend({
        template: "partner_print_credit.PrintCredit",
        resPartner: [],
        resConyuge: [],
        jsonDoc: [],
        ref_Personal: [],
        ref_Comercial: [],
        // Init
        init: function(parent) {
            this._super(parent);
        },
        start: function () {
            var self = this;
            this.$el.click(function() {
                self.fecthInitial();
            });
        },
        fecthInitial: function() {
            var id = openerp.webclient._current_state.id;
            var self = this;
            self.fecthPartner(id).then(function(partner) {
                return partner;
            }).then(function(partner) {
                self.resPartner = partner;
                return self.fecthPartnerConyuge();
            }).then(function(res_conyuge) {
                self.resConyuge = res_conyuge;
                return self.fecthPartnerPersonal();
            }).then(function(ref_Personal) {
                self.ref_Personal = ref_Personal;
                return self.fecthPartnerComercial();
            }).then(function(ref_Comercial) {
                self.ref_Comercial = ref_Comercial;
                return self.drawJSON();
            }).then(function(jsondoc) {
                self.jsonDoc = jsondoc
                return self.drawPDF();
            });
        },
        // Consultar Cliente
        fecthPartner: function(id) {
            var defer = $.Deferred();
            var fields = ['id', 'name', 'ruc', 'estado_civil', 'city', 'fecha_credito', 'street', 'phone', 'mobile', 'email', 'user_id', 'casa_propia',  'casa_alquiler', 'trab_empresa', 'trab_telefono', 'trab_street', 'trab_city', 'trab_cargo', 'trab_salario', 'trab_antiguedad_a', 'trab_antiguedad_m',  'conyuge_id', 'ref_personal_ids', 'ref_comercial_ids'];
            var domain = [['id', 'in', [id]]];
            var Partner = new openerp.web.Model('res.partner');
            Partner.query(fields).filter(domain).order_by('id').all().then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },
        // Consultar Conyugue
        fecthPartnerConyuge: function() {
            var self = this;
            var defer = $.Deferred();
            var partnerIDS = _.flatten(_.map(self.resPartner, function (item) {
                return item.conyuge_id[0];
            }));
            var fields = ['id', 'name', 'ruc', 'city', 'street', 'phone', 'mobile', 'email', 'trab_empresa', 'trab_telefono', 'trab_street', 'trab_city'];
            var domain = [['id', 'in', partnerIDS]];
            var Partner = new openerp.web.Model('res.partner');
            Partner.query(fields).filter(domain).order_by('id').all().then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },
        // Consultar Conyugue
        fecthPartnerPersonal: function() {
            var self = this;
            var defer = $.Deferred();
            var partnerIDS = _.flatten(_.map(self.resPartner, function (item) {
                return item.ref_personal_ids;
            }));
            var fields = ['id', 'name', 'phone', 'mobile'];
            var domain = [['id', 'in', partnerIDS]];
            var Partner = new openerp.web.Model('res.partner');
            Partner.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },
        // Consultar Conyugue
        fecthPartnerComercial: function() {
            var self = this;
            var defer = $.Deferred();
            var partnerIDS = _.flatten(_.map(self.resPartner, function (item) {
                return item.ref_comercial_ids;
            }));
            var fields = ['id', 'name', 'phone', 'mobile'];
            var domain = [['id', 'in', partnerIDS]];
            var Partner = new openerp.web.Model('res.partner');
            Partner.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },
        // Obtener Datos del JSON
        drawJSON: function() {
            var defer = $.Deferred();
            $.getJSON('/partner_print_credit/static/src/json/print_credit.json').then(function(doc) {
                defer.resolve(doc);
            });

            return defer;
        },
        // verificar null
        checkNull: function(dato) {
            var valor = "";
            if (dato) {
                if(dato === true && typeof dato === 'boolean'){
                    valor = "X";
                }else{
                    valor = dato;
                }
            }
            return valor;
        },
        // Generar Objeto de Partner
        generateCustomer: function(resPartner) {
            var self = this;
            var doc = [];

            if (!resPartner)
                return

            doc.push({
                fecha: self.checkNull(moment(resPartner.fecha_credito).format('DD-MM-YYYY')),
                id: self.checkNull(resPartner.id),
                name: self.checkNull(resPartner.name),
                ruc: self.checkNull(resPartner.ruc),
                estado_civil: self.checkNull(resPartner.estado_civil),
                city: self.checkNull(resPartner.city),
                street: self.checkNull(resPartner.street),
                phone: self.checkNull(resPartner.phone),
                mobile: self.checkNull(resPartner.mobile),
                email: self.checkNull(resPartner.email),
                user: self.checkNull(resPartner.user_id[1]),
                casa_propia: self.checkNull(resPartner.casa_propia),
                casa_alquiler: self.checkNull(resPartner.casa_alquiler),
                trab_empresa: self.checkNull(resPartner.trab_empresa),
                trab_telefono: self.checkNull(resPartner.trab_telefono),
                trab_street: self.checkNull(resPartner.trab_street),
                trab_city: self.checkNull(resPartner.trab_city),
                trab_cargo: self.checkNull(resPartner.trab_cargo),
                trab_salario: self.checkNull(accounting.formatNumber(resPartner.trab_salario , 2, ".", ",")),
                trab_antiguedad_a: self.checkNull(resPartner.trab_antiguedad_a),
                trab_antiguedad_m: self.checkNull(resPartner.trab_antiguedad_m)
            });

            return doc;

        },
        // Generar el PDF
        drawPDF:function() {
            var self = this;
            var doc;
            var pdfDoc = new jsPDF();
            var resPartner = self.resPartner.shift();
            var resConyuge = self.resConyuge.shift();
            var ref_Personal = self.ref_Personal;
            var ref_Comercial = self.ref_Comercial;
            doc = self.generateCustomer(resPartner);

            if (!doc)
                return

            _.each(doc, function(item) {
                _.each(self.jsonDoc, function(jsondoc) {
                    var texto =_.template(jsondoc.content)(item);
                    pdfDoc.setFontSize(jsondoc.size);
                    pdfDoc.setFontStyle(jsondoc.fontStyle);
                    pdfDoc.text(jsondoc.x, jsondoc.y, pdfDoc.splitTextToSize(texto, 180), null, null, jsondoc.position);
                })
            })

            if(!resConyuge) {
                resConyuge = {};
                resConyuge.name = "";
                resConyuge.ruc = "";
                resConyuge.phone = "";
                resConyuge.mobile = "";
                resConyuge.street = "";
                resConyuge.trab_empresa = "";
                resConyuge.trab_telefono = "";
                resConyuge.trab_street = "";
                resConyuge.city = "";
            }

            pdfDoc.setFontSize('10');
            pdfDoc.setFontStyle('normal');
            pdfDoc.text(15,105, pdfDoc.splitTextToSize('Nombre y Apellido: '+self.checkNull(resConyuge.name),180));
            pdfDoc.text(140,105, pdfDoc.splitTextToSize('Cédula de Identidad Nro: '+self.checkNull(resConyuge.ruc),180));
            pdfDoc.text(15,110, pdfDoc.splitTextToSize('Teléfono Particular/Móvil: '+self.checkNull(resConyuge.phone)+" "+self.checkNull(resConyuge.mobile),180));
            pdfDoc.text(140,110, pdfDoc.splitTextToSize('Ciudad: '+self.checkNull(resConyuge.city),180));
            pdfDoc.text(15,115, pdfDoc.splitTextToSize('Direccion: '+self.checkNull(resConyuge.street),180));
            pdfDoc.text(15,120, pdfDoc.splitTextToSize('Empresa o Lugar de Trabajo: '+self.checkNull(resConyuge.trab_empresa),180));
            pdfDoc.text(140,120, pdfDoc.splitTextToSize('Teléfono: '+self.checkNull(resConyuge.trab_telefono),180));
            pdfDoc.text(15,125, pdfDoc.splitTextToSize('Dirección Laboral: '+self.checkNull(resConyuge.trab_street),180));

            var y = 0;
            if(ref_Personal.length > 0 ){
                y = 135;
                _.each(ref_Personal, function(item, index) {
                    if (index < 3) {
                        pdfDoc.setFontSize('10');
                        pdfDoc.setFontStyle('normal');
                        pdfDoc.text(15, y, pdfDoc.splitTextToSize((index+1)+'.'+self.checkNull(item.name), 180));
                        pdfDoc.text(130, y, pdfDoc.splitTextToSize('Teléfono:  '+self.checkNull(item.phone)+" / "+self.checkNull(item.mobile), 180));
                        y = y + 5
                    }
                })
            }else{
                y = 135;
                ref_Personal.push({
                    'name': '.........................................',
                    'mobile': '.................................'
                });
                _.each(ref_Personal, function(item, index) {
                    pdfDoc.text(15, y,  pdfDoc.splitTextToSize((index+1)+'.'+item.name, 180));
                    pdfDoc.text(130, y, pdfDoc.splitTextToSize('Teléfono: '+item.mobile, 180));
                    y = y + 5;
                    pdfDoc.text(15, y,  pdfDoc.splitTextToSize((index+1)+'.'+item.name, 180));
                    pdfDoc.text(130, y, pdfDoc.splitTextToSize('Teléfono: '+item.mobile, 180));
                })
            }
            if(ref_Comercial.length > 0 ){
                y = 155;
                _.each(ref_Comercial, function(item, index) {
                    if (index < 3){
                        pdfDoc.setFontSize('10');
                        pdfDoc.setFontStyle('normal');
                        pdfDoc.text(15,y, pdfDoc.splitTextToSize( (index+1)+'.'+self.checkNull(item.name),180));
                        pdfDoc.text(130,y, pdfDoc.splitTextToSize('Teléfono:  '+self.checkNull(item.phone)+" "+self.checkNull(item.mobile),180));
                        y = y + 5
                    }
                })
            }else{
                y = 155;
                ref_Comercial.push({
                    'name': '........................................',
                    'mobile': '.................................'
                });
                _.each(ref_Comercial, function(item, index) {
                    pdfDoc.text(15, y,  pdfDoc.splitTextToSize((index+1)+'.'+item.name, 180));
                    pdfDoc.text(130, y, pdfDoc.splitTextToSize('Teléfono: '+item.mobile, 180));
                    y = y + 5;
                    pdfDoc.text(15, y,  pdfDoc.splitTextToSize((index+1)+'.'+item.name, 180));
                    pdfDoc.text(130, y, pdfDoc.splitTextToSize('Teléfono: '+item.mobile, 180));
                })
            }
            pdfDoc.save('SOLICITUD_CREDITO_PERSONAL.pdf');
        },
    });

    if(openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
          load_form: function(){
              if(this.model === 'res.partner') {
                var padre = this.$el.closest('.oe_clear.ui-tabs.ui-widget.ui-widget-content.ui-corner-all');
                if (padre) {
                    var partnerPrint = new openerp.partner_print_credit.PrintCreditWidget(this);
                    partnerPrint.insertBefore(padre);
                }
              }
              return this._super.apply(this, arguments);
          }
        });
    }
})();
